import 'package:flutter/material.dart';

class GraphEdge {

  static const String INVALID_ID = "-1";
  static int _nextValidID = 1;
  static int get nextValidID => _nextValidID++;
  /// returns the String representation of the edge
  static String get nextID => nextValidID.toString();

  String id;
  String from;
  String to;
  bool biDirectional;

  GraphEdge(this.id, this.from, this.to, {this.biDirectional = false});

  GraphEdge copy() {
    return GraphEdge(
      this.id,
      this.from,
      this.to,
      biDirectional: this.biDirectional
    );
  }


  @override bool operator ==(Object other) {
    if (other is GraphEdge) {
      return other.id == id;
      
      // return  (other.to == this.from || other.from == this.to);
      
    }

    return false;
  }

  bool equalByEndPoints(GraphEdge other) {
     return  (other.to == this.from && other.from == this.to) ||
     (other.from == this.from && other.to == this.to);
  }

  @override
  int get hashCode => hashValues(from, to);

  @override String toString() {
    return 'from:$from to:$to biDirectional:$biDirectional';
  }
}